package com.huimv.env.produce.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.common.utils.Result;
import com.huimv.common.utils.ResultCode;
import com.huimv.env.common.utils.DateUtil;
import com.huimv.env.produce.entity.Birth;
import com.huimv.env.produce.entity.Cost;
import com.huimv.env.produce.mapper.CostMapper;
import com.huimv.env.produce.service.CostService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author zn
 * @since 2022-10-30
 */
@Service
public class CostServiceImpl extends ServiceImpl<CostMapper, Cost> implements CostService {
    @Autowired
    private CostMapper costMapper;

    @Override
    public Result getCostInYearAndMonth(Map<String, String> paramsMap) {
        DateUtil dateUtil = new DateUtil();
        String farmCode = paramsMap.get("farmCode");
        QueryWrapper<Cost> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("farm_code",farmCode);
        queryWrapper.eq("year",dateUtil.getThisYear());
        queryWrapper.eq("month",dateUtil.getThisMonth());
        Cost cost = costMapper.selectOne(queryWrapper);
        System.out.println("cost="+cost);
        if(cost == null){
            cost = new Cost();
            cost.setAllDrugCost(new BigDecimal(0));
            cost.setAllFeedCost(new BigDecimal(0));
            cost.setAllSharedCost(new BigDecimal(0));
            cost.setBoarDrugCost(new BigDecimal(0));
            cost.setBoarFeedCost(new BigDecimal(0));
            cost.setBoarSharedCost(new BigDecimal(0));
            cost.setSowDrugCost(new BigDecimal(0));
            cost.setSowFeedCost(new BigDecimal(0));
            cost.setSowSharedCost(new BigDecimal(0));
            cost.setFatpigDrugCost(new BigDecimal(0));
            cost.setFatpigFeedCost(new BigDecimal(0));
            cost.setFatpigSharedCost(new BigDecimal(0));
        }
        return new Result(ResultCode.SUCCESS,cost);
    }
}
